#include "CCar.h"


CSinCosTable SinCosTable;


CCar::~CCar()
{
    if(PShadow)
    {
        SDL_FreeSurface(PShadow);
        PShadow = NULL;
    }
    if(POriginalSurface)
    {
        SDL_FreeSurface(POriginalSurface);
        POriginalSurface = NULL;
    }
    if(PSurface)
    {
        SDL_FreeSurface(PSurface);
        PSurface = NULL;
    }
    if(POriginalMaskSurface)
    {
        SDL_FreeSurface(POriginalMaskSurface);
        POriginalMaskSurface = NULL;
    }
    if(PMaskSurface)
    {
        SDL_FreeSurface(PMaskSurface);
        PMaskSurface = NULL;
    }
}

void CCar::Jump()
{
    if(!PJumping)
        PJumping = true;
}

CCar::CCar() {
  POriginalSurface = NULL;
  PSurface = NULL;
  PMaskSurface=NULL;
  POriginalMaskSurface = NULL;
  PShadow=NULL;
  PAngle = 0;
  PTurnAngle = 0;
  PX = 0;
  PY = 0;
  PInitialX = PX;
  PInitialY = PY;
  PSpeed = 0;
  PAcceleration =0;
  PBounce = false;
  PMaxJumpHeight =float2fix<Precission>(1.8);
  PJumpHeight = float2fix<Precission>(1);
  PJumpIncrease =float2fix<Precission>(0.10);
  PMaxAccelerationNitro = 0;
  PMaxSpeedNitro = 0;
  PJumping =false;
  PLanding = false;
  PResetting = false;
  PLanded=false;
  PSlippingWater = false;
  PBounces = 0;
  PBounceSteps = 0;
  PResetSteps = 0;
  UpdateAngle();
  PVisible = true;
  PReplayRecording = false;
  PHasBounced=false;
  PCheckPoint1Passed = true;
  PCheckPoint2Passed = true;
  PFinishedPassed = true;
  POverLogicalPortHorzEnter = false;
  POverLogicalPortHorzLeave = false;
  POverLogicalPortVertEnter = false;
  POverLogicalPortVertLeave = false;
  POverBridge = false;
  PLastPort = -1;
  PLogicalPortHorzEnteredAngleEnter=-1;
  PLogicalPortVertEnteredAngleEnter=-1;
  PLogicalPortHorzEnteredAngleLeave=-1;
  PLogicalPortVertEnteredAngleLeave=-1;
  PId = DCARID;
  PInOnBridge=true;
  PLogicalPortHorzValue = true;
  PLogicalPortVertValue = true;
  PLaps = 0;
  PMaxTurnAngle = float2fix<Precission>(4.0);
  PAngleInc = float2fix<Precission>(0.40);
  PCanMove = false;
}

CCar :: CCar(char* filename,char* filenamemask,char* filenameshadow, int Xin,int Yin,int Angle)
{
  SDL_Surface *Tmp;
  Tmp = IMG_Load(filename);
  SDL_SetColorKey(Tmp,SDL_SRCCOLORKEY,SDL_MapRGB(Tmp->format,255,0,255));
  POriginalSurface = SDL_DisplayFormat(Tmp);
  SDL_FreeSurface(Tmp);

  Tmp = IMG_Load(filenamemask);
  POriginalMaskSurface = SDL_DisplayFormat(Tmp);
  SDL_FreeSurface(Tmp);

  Tmp = IMG_Load(filenameshadow);
  SDL_SetColorKey(Tmp,SDL_SRCCOLORKEY,SDL_MapRGB(Tmp->format,255,0,255));
  PShadow = SDL_DisplayFormat(Tmp);
  SDL_FreeSurface(Tmp);

  PMaskSurface = NULL;
  PSurface = NULL;
  PAngle = Angle;
  PTurnAngle = 0;
  PX = (Xin ) << Precission;
  PY = (Yin ) << Precission;
  PInitialX = PX;
  PInitialY = PY;
  PSpeed = 0;
  PAcceleration =0;
  PBounce = false;
  PMaxJumpHeight =float2fix<Precission>(1.8);
  PJumpHeight = float2fix<Precission>(1);
  PJumpIncrease =float2fix<Precission>(0.10);
  PMaxAccelerationNitro = 0;
  PMaxSpeedNitro = 0;
  PJumping =false;
  PLanding = false;
  PResetting = false;
  PLanded=false;
  PSlippingWater = false;
  PBounces = 0;
  PBounceSteps = 0;
  PResetSteps = 0;
  UpdateAngle();
  PVisible = true;
  PReplayRecording = false;
  PHasBounced=false;
  PCheckPoint1Passed = true;
  PCheckPoint2Passed = true;
  PFinishedPassed = true;
  POverLogicalPortHorzEnter = false;
  POverLogicalPortHorzLeave = false;
  POverLogicalPortVertEnter = false;
  POverLogicalPortVertLeave = false;
  PLogicalPortHorzValue = true;
  PLogicalPortVertValue = true;
  POverBridge = false;
  PLastPort = -1;
  PLogicalPortHorzEnteredAngleEnter=-1;
  PLogicalPortVertEnteredAngleEnter=-1;
  PLogicalPortHorzEnteredAngleLeave=-1;
  PLogicalPortVertEnteredAngleLeave=-1;
  PId = DCARID;
  PInOnBridge=true;
  PLaps = 0;
  PMaxTurnAngle = float2fix<Precission>(4.0);
  PAngleInc = float2fix<Precission>(0.40);
  PCanMove = false;
}

CCar::CCar(char* filename,char* filenamemask,char* filenameshadow,int Xin,int Yin,int Angle,double MaxSpeed, double MaxAcceleration, double AccelStep) {

  SDL_Surface *Tmp;

  Tmp = IMG_Load(filename);
  SDL_SetColorKey(Tmp,SDL_SRCCOLORKEY,SDL_MapRGB(Tmp->format,255,0,255));
  POriginalSurface = SDL_DisplayFormat(Tmp);
  SDL_FreeSurface(Tmp);

  Tmp = IMG_Load(filenamemask);
  POriginalMaskSurface = SDL_DisplayFormat(Tmp);
  SDL_FreeSurface(Tmp);

  Tmp = IMG_Load(filenameshadow);
  SDL_SetColorKey(Tmp,SDL_SRCCOLORKEY,SDL_MapRGB(Tmp->format,255,0,255));
  PShadow = SDL_DisplayFormat(Tmp);
  SDL_FreeSurface(Tmp);

  PMaskSurface = NULL;
  PSurface = NULL;
  PAngle = Angle;
  PTurnAngle = 0;
  PX = (Xin ) << Precission;
  PY = (Yin ) << Precission;
  PInitialX = PX;
  PInitialY = PY;
  PAccelStep = float2fix<Precission>(AccelStep);
  PMaxSpeed = float2fix<Precission>(MaxSpeed) ;
  PMaxAcceleration = float2fix<Precission>(MaxAcceleration);
  PSpeed = 0;
  PAcceleration =0;
  PBounce = false;
  PMaxJumpHeight =float2fix<Precission>(1.8);
  PJumpHeight = float2fix<Precission>(1);
  PJumpIncrease =float2fix<Precission>(0.10);
  PMaxAccelerationNitro = float2fix<Precission>(MaxAcceleration*1.5);
  PMaxSpeedNitro = float2fix<Precission>(MaxSpeed*2);
  PJumping =false;
  PLanding = false;
  PResetting = false;
  PLanded=false;
  PSlippingWater = false;
  PBounces = 0;
  PBounceSteps = 0;
  PResetSteps = 0;
  UpdateAngle();
  PVisible = true;
  PReplayRecording = false;
  PHasBounced = false;
  PCheckPoint1Passed = true;
  PCheckPoint2Passed = true;
  PFinishedPassed = true;
  POverBridge = false;
  PLastPort = -1;
  PLogicalPortHorzEnteredAngleEnter=-1;
  PLogicalPortVertEnteredAngleEnter=-1;
  PLogicalPortHorzEnteredAngleLeave=-1;
  PLogicalPortVertEnteredAngleLeave=-1;
  POverLogicalPortHorzEnter = false;
  POverLogicalPortHorzLeave = false;
  POverLogicalPortVertEnter = false;
  POverLogicalPortVertLeave = false;
  PLogicalPortHorzValue = true;
  PLogicalPortVertValue = true;
  PId = DCARID;
  PInOnBridge=true;
  PLaps = 0;
  PMaxTurnAngle = float2fix<Precission>(4.0);
  PAngleInc = float2fix<Precission>(0.40);
  PCanMove = false;
}

CCar::CCar(char* filename,char* filenamemask,char* filenameshadow,int Xin,int Yin,int Angle,double MaxSpeed, double MaxAcceleration,double AccelStep,double MaxTurnAngle,double AngleInc )
{
  SDL_Surface *Tmp;
  Tmp = IMG_Load(filename);
  SDL_SetColorKey(Tmp,SDL_SRCCOLORKEY,SDL_MapRGB(Tmp->format,255,0,255));
  POriginalSurface = SDL_DisplayFormat(Tmp);
  SDL_FreeSurface(Tmp);


  Tmp = IMG_Load(filenamemask);
  POriginalMaskSurface = SDL_DisplayFormat(Tmp);
  SDL_FreeSurface(Tmp);

  Tmp = IMG_Load(filenameshadow);
  SDL_SetColorKey(Tmp,SDL_SRCCOLORKEY,SDL_MapRGB(Tmp->format,255,0,255));
  PShadow = SDL_DisplayFormat(Tmp);
  SDL_FreeSurface(Tmp);

  PMaskSurface = NULL;
  PSurface = NULL;
  PAngle = Angle;
  PTurnAngle = 0;
  PX = (Xin ) << Precission;
  PY = (Yin ) << Precission;
  PInitialX = PX;
  PInitialY = PY;
  PAccelStep = float2fix<Precission>(AccelStep);
  PMaxSpeed = float2fix<Precission>(MaxSpeed) ;
  PMaxAcceleration = float2fix<Precission>(MaxAcceleration);
  PSpeed = 0;
  PAcceleration =0;
  PBounce = false;
  PMaxJumpHeight =float2fix<Precission>(1.8);
  PJumpHeight = float2fix<Precission>(1);
  PJumpIncrease =float2fix<Precission>(0.10);
  PMaxAccelerationNitro = float2fix<Precission>(MaxAcceleration*1.5);
  PMaxSpeedNitro = float2fix<Precission>(MaxSpeed*2);
  PJumping =false;
  PLanding = false;
  PResetting = false;
  PLanded=false;
  PSlippingWater = false;
  PBounces = 0;
  PBounceSteps = 0;
  PResetSteps = 0;
  UpdateAngle();
  PVisible = true;
  PReplayRecording = false;
  PHasBounced = false;
  PCheckPoint1Passed = true;
  PCheckPoint2Passed = true;
  PFinishedPassed = true;
  POverBridge = false;
  PLastPort = -1;
  PLogicalPortHorzEnteredAngleEnter=-1;
  PLogicalPortVertEnteredAngleEnter=-1;
  PLogicalPortHorzEnteredAngleLeave=-1;
  PLogicalPortVertEnteredAngleLeave=-1;
  POverLogicalPortHorzEnter = false;
  POverLogicalPortHorzLeave = false;
  POverLogicalPortVertEnter = false;
  POverLogicalPortVertLeave = false;
  PLogicalPortHorzValue = true;
  PLogicalPortVertValue = true;
  PId = DCARID;
  PInOnBridge=true;
  PLaps = 0;
  PMaxTurnAngle = float2fix<Precission>(MaxTurnAngle);
  PAngleInc = float2fix<Precission>(AngleInc);
  PCanMove = false;
}



//void CCar::ResetCar(){
    //PLanded = false;
    //PResetting=true;
//}
void CCar::SetCollisionAngle(CCar *Car)
{


}

bool CCar::Intersects(SDL_Rect *Rect) {
    if ((fix2float<Precission>(PX) + (PSurface->w/2) > Rect->x-1) &&
        (fix2float<Precission>(PY) + (PSurface->h/2) > Rect->y-1) &&
        (fix2float<Precission>(PX) -(PSurface->w/2) < Rect->x + Rect->w -1) &&
        (fix2float<Precission>(PY) -(PSurface->h/2) < Rect->y + Rect->h -1))
            return true;
    else
            return false;
}

void CCar::SlipWater(int AngleInc)
{
    //if(fix2float<Precission>(PSpeed) > float2fix<Precission>(fix2float<Precission>((int)(PMaxSpeed*0.25))))
      //  PSpeed = float2fix<Precission>(fix2float<Precission>((int)(PSpeed*0.50)));
    if(rand()%2 == 1)
    {
        //TurnLeft((int)(fix2float<Precission>(PSpeed)/fix2float<Precission>(PMaxSpeed) *AngleInc));
        TurnLeft();
    }
    else
        //TurnRight((int)(fix2float<Precission>(PSpeed)/fix2float<Precission>(PMaxSpeed) *AngleInc));
        TurnRight();

    //PAcceleration -= PAccelStep;
    //SetAngle(GetAngle()+(rand()%AngleInc)-AngleInc/2);
   // PVelY = float2fix<Precission>((fix2float<Precission>(PSpeed) /2)*SinCosTable.GetSin(PAngle));
   // PVelX = float2fix<Precission>((fix2float<Precission>(PSpeed) /2)*SinCosTable.GetCos(PAngle));
    //PX += PVelX;
    //PY += PVelY;
   // if (PAcceleration < 0<<Precission)
     //   PAcceleration = 0<<Precission;
   // PAngle + = AngleInc;
   // PVelY = float2fix<Precission>(fix2float<Precission>(PSpeed)*SinCosTable.GetSin(PAngle));
   // PVelX = float2fix<Precission>(fix2float<Precission>(PSpeed)*SinCosTable.GetCos(PAngle));
   // PX += PVelX;
   // PY += PVelY;
}

void CCar::ResetCar()
{
    printf("bleh\n");
    //Accelerate(false);
    //PSpeed = 0;
//    if(PSpeed ==0)
        //PSpeed = 0;
   // PAcceleration = 0;

    //PVelY = float2fix<Precission>(fix2float<Precission>(PSpeed)*SinCosTable.GetSin(PAngle));
    //PVelX = float2fix<Precission>(fix2float<Precission>(PSpeed)*SinCosTable.GetCos(PAngle));


    //PResetSteps+= 1;
    //if(PResetSteps == 5)
   // {
    //    PBounces = 0;
    //    PResetSteps = 0;
        PResetting = true;
        //PBounces = 0;
        /*
        vector<SPoint>::iterator iter1;
        for(int teller=0;teller<10;teller++)
        {
            Points.pop_back();
        }
        iter1=Points.end();
        PX = iter1->X;
        PY = iter1->Y;
        PSpeed = 0;
        PAcceleration = 0;
        */
   // }
    //if(fix2float<Precission>(PVelY) > 0)

    //if(fix2float<Precission>(PVelX) > 0)

}

float CCar::GetBounceToX()
{
   return fix2float<Precission>(PX - (20* SinCosTable.GetCos(PAngle)));
}

float CCar::GetBounceToY()
{
   return fix2float<Precission>(PY - (20* SinCosTable.GetSin(PAngle)));
}

void CCar::StopBounce()
{
    SetAngleNoUpdate(PAngle + 180);
    PX += 2*PVelX;
    PY += 2*PVelY;

    PVelY = 0;
    PVelX = 0;
    PAcceleration = 0;
    PBounceSteps = 0;
    PSpeed=0;
    PBounce = false;
}

void CCar::Move() {
    ////  PLanded = false;
   // if(PBounces < 5)

    SDL_Surface *Tmp;
    if(PCanMove)
    {
       if( PResetting)
       {
            if(PResetSteps < 10)
            {
                PSpeed=0;
                PAcceleration = 0;

                vector<SPoint>::iterator Iter;
                Iter = Points.end()-1-PResetSteps;
                PX = Iter->X;
                PY = Iter->Y;
                PAngle = Iter->Angle;
                UpdateAngle();
                PResetSteps++;
                //Points.pop_back();
            }
            else
            {
                PResetSteps=0;
                PResetting = false;
            }
       }
       else
       {
            if(PBounce)
            {
                if(PBounceSteps < 10)
                {
                    PSpeed = 10*PMaxAcceleration;
                    PBounceSteps++;
                    PVelY = fixmul<Precission>(PSpeed,SinCosTable.GetSin(PAngle));
                    PVelX = fixmul<Precission>(PSpeed,SinCosTable.GetCos(PAngle));
                    //PVelX = 0;
                    //PVelY =0;
                    PAcceleration = 0;
                }
                else
                {
                    SetAngleNoUpdate(PAngle + 180);
                    PVelY = 0;
                    PVelX = 0;
                    PAcceleration = 0;
                    PBounceSteps = 0;
                    PSpeed=0;
                    PBounce = false;
                }

               /* if(PBounceSteps < 20)
                {
                    PBounceSteps++;
                    PX +=  float2fix<Precission>(SinCosTable.GetCos(PAngle));
                    PY +=  float2fix<Precission>(SinCosTable.GetSin(PAngle));
                    PSpeed=0;
                    PVelX = 0;
                    PAcceleration = 0;
                    PVelY = 0;
                }
                else
                {
                    SetAngleNoUpdate(PAngle + 180);
                    PVelY = 0;
                    PVelX = 0;
                    PAcceleration = 0;
                    PBounceSteps = 0;
                    PSpeed=0;
                    PBounce = false;

                }*/
            }
       }
       PX += PVelX;
       PY += PVelY;
    //else
  //  {
     //   ResetCar();
    //}

    if (fix2float<Precission>(PX) + PSurface->w/2 > WINDOW_WIDTH  -1)
    {
        //PX = (WINDOW_WIDTH- 1 - PSurface->w/2) << Precission;
       // Bounce();
    }
    if (fix2float<Precission>(PY) + PSurface->h/2 > WINDOW_HEIGHT -1)
    {
        //PY = (WINDOW_HEIGHT  -1 -  PSurface->h/2)  << Precission;
        //Bounce();
    }

    if (fix2float<Precission>(PX) -PSurface->w/2 < 0)
    {
        //PX = (PSurface->w/2)<<Precission;
        //Bounce();
    }
    if (fix2float<Precission>(PY) -PSurface->h/2 < 0 )
    {
        //PY = (PSurface->h/2)<<Precission;
        //Bounce();
    }


    if(PJumping)
    {
        PJumpHeight+=PJumpIncrease;
        if((PJumpHeight > PMaxJumpHeight) && !PLanding)
        {
            PJumpIncrease = - (PJumpIncrease);
            PLanding = true;
        }
        else
        {
            if(PJumpHeight < 1<<Precission)
            {
                PJumpHeight = 1<<Precission;
                PJumpIncrease= -(PJumpIncrease) ;
                PJumping=false;
                PLanding=false;
                PLanded=true;
                printf("Landed !\n");
            }
        }
        if(PSurface)
        {
            SDL_FreeSurface(PSurface);
            PSurface= NULL;
        }
        if(PMaskSurface)
        {
            SDL_FreeSurface(PMaskSurface);
            PMaskSurface= NULL;
        }
        if(PBounce)
        {
//WEIRD but had to do it diffrent for ubuntu, dunno why!!!
#ifdef LINUX
            Tmp = rotozoomSurface(POriginalSurface,180-PAngle,fix2float<Precission>(PJumpHeight),0);
            PSurface = SDL_DisplayFormat(Tmp);
            SDL_FreeSurface(Tmp);
            SDL_SetColorKey(PSurface,SDL_SRCCOLORKEY,SDL_MapRGB(PSurface->format,255,0,255));
#else
            PSurface = rotozoomSurface(POriginalSurface,180-PAngle,fix2float<Precission>(PJumpHeight),0);
#endif
            PMaskSurface = rotozoomSurface(POriginalMaskSurface,180-PAngle,1,0);

        }
        else
        {
//WEIRD but had to do it diffrent for ubuntu, dunno why!!!
#ifdef LINUX
            Tmp = rotozoomSurface(POriginalSurface,360-PAngle,fix2float<Precission>(PJumpHeight),0);
            PSurface = SDL_DisplayFormat(Tmp);
            SDL_FreeSurface(Tmp);
            SDL_SetColorKey(PSurface,SDL_SRCCOLORKEY,SDL_MapRGB(PSurface->format,255,0,255));
#else
            PSurface = rotozoomSurface(POriginalSurface,360-PAngle,fix2float<Precission>(PJumpHeight),0);
#endif
            PMaskSurface = rotozoomSurface(POriginalMaskSurface,360-PAngle,1,0);

        }

    }

    if(PReplayRecording)
    {
        SPoint Point;
        Point.X = PX;
        Point.Y = PY;
        Point.VelX = PVelX;
        Point.VelY = PVelY;
        Point.Angle = PAngle;
        Point.JumpHeight = PJumpHeight;
        Point.Bouncing = PBounce;
        Points.push_back(Point);
    }
    //DeAccelerate();
    }

}
void CCar::SetAngleNoUpdate(int Angle)
{
    PAngle = Angle;
     if (PAngle < 0)
            PAngle = 360 + PAngle %360;
        else
            if (PAngle > 359)
                PAngle = PAngle%360;
   //printf("Car Angle %d\n",PAngle);
    PVelY = fixmul<Precission>(PSpeed,SinCosTable.GetSin(PAngle));
    PVelX = fixmul<Precission>(PSpeed,SinCosTable.GetCos(PAngle));
}

void CCar::SetAngle(int Angle) {
    if( !PJumping)
    {

        PAngle = Angle;
        UpdateAngle();
    }
}



void CCar::UpdateAngle()
{
    SDL_Surface *Tmp;
    if (PAngle < 0)
            PAngle = 360 + PAngle %360;
        else
            if (PAngle > 359)
                PAngle = PAngle%360;
   //printf("Car Angle %d\n",PAngle);
    PVelY = fixmul<Precission>(PSpeed,SinCosTable.GetSin(PAngle));
    PVelX = fixmul<Precission>(PSpeed,SinCosTable.GetCos(PAngle));
    if(PSurface)
    {
        SDL_FreeSurface(PSurface);
        PSurface = NULL;
    }
//WEIRD but had to do it diffrent for ubuntu, dunno why!!!
#ifdef LINUX
    Tmp = rotozoomSurface(POriginalSurface,360-PAngle,fix2float<Precission>(PJumpHeight),0);
    PSurface = SDL_DisplayFormat(Tmp);
    SDL_FreeSurface(Tmp);
#else
    PSurface = rotozoomSurface(POriginalSurface,360-PAngle,fix2float<Precission>(PJumpHeight),0);
#endif
    SDL_SetColorKey(PSurface,SDL_SRCCOLORKEY,SDL_MapRGB(PSurface->format,255,0,255));

    if(PMaskSurface)
    {
        SDL_FreeSurface(PMaskSurface);
        PMaskSurface = NULL;
    }
    PMaskSurface = rotozoomSurface(POriginalMaskSurface,360-PAngle,1,0);

}

void CCar::TurnLeft() {
    if( !PJumping & !PBounce &&!PResetting && PCanMove)
    {
        if (PTurnAngle > 0)
            PTurnAngle = 0;
        PTurnAngle -= PAngleInc;
        if(PTurnAngle < -PMaxTurnAngle)
            PTurnAngle = -PMaxTurnAngle;

        PAngle += (int)fix2float<Precission>(PTurnAngle);
        UpdateAngle();
    }
}

void CCar::TurnRight() {
    if( !PJumping && !PBounce && !PResetting&& PCanMove)
    {
        if (PTurnAngle < 0)
            PTurnAngle = 0;
        PTurnAngle += PAngleInc;
        if(PTurnAngle > PMaxTurnAngle)
            PTurnAngle = PMaxTurnAngle;

        PAngle += (int)fix2float<Precission>(PTurnAngle);
        UpdateAngle();
    }
}

void CCar::ResetTurnAngle() {
    if(PTurnAngle !=0)
    {
        if(PTurnAngle < 0)
            PTurnAngle +=PAngleInc;
        if(PTurnAngle > 0)
            PTurnAngle -=PAngleInc;
    }
}

void CCar::Bounce()
{

    //PBounces++;
   // if(PBounces < 5)
   // {
        PBounce = true;
        PHasBounced = true;
        SetAngleNoUpdate(PAngle + 180);
        PX += PVelX;
        PY += PVelY;
        //PX -=PVelX;
        //PY -= PVelY;
       //ReverseSpeed();
       // PSpeed = -PSpeed;
       // PAngle = PAngle - 180;
       // if (PAngle < 0)
 //           PAngle = 360 + PAngle %360;

       /* if(fix2float<Precission>(PSpeed) >= 0)
        {
            PSpeed =  -fixdiv<Precission>(PSpeed,float2fix<Precission>(1.5));
            PAcceleration = 0;
        }
        else
         PSpeed = -PSpeed;

        PAcceleration = 0;
        PVelY = float2fix<Precission>(fix2float<Precission>(PSpeed)*SinCosTable.GetSin(PAngle));
        PVelX = float2fix<Precission>(fix2float<Precission>(PSpeed)*SinCosTable.GetCos(PAngle));





 //   }
   // else
     //   PResetting=true;


        //PX += PVelX;
    //PY += PVelY;

    if (fix2float<Precission>(PX) + PSurface->w/2 < ScreenRect->w +Screen  -1)
    {
        PX = (ScreenRect->w - 1 - PSurface->w/2) << Precission;
        Bounce();
    }
    if (fix2float<Precission>(PY) + PSurface->h/2 > ScreenRect->h -1)
    {
        PY = (ScreenRect->h -1 -  PSurface->h/2)  << Precission;
        Bounce();
    }

    if (fix2float<Precission>(PX) -PSurface->w/2 > ScreenRect->x)
    {
        PX = (PSurface->w/2)<<Precission;
        Bounce();
    }
    if (fix2float<Precission>(PY) -PSurface->h/2 > ScreenRect->y )
    {
        PY = (PSurface->h/2)<<Precission;
        Bounce();
    }
    */


    //if(PSpeed < 0)
      //  PSpeed = 0;

}

SDL_Rect CCar::GetRect()
{
    SDL_Rect Tmp;
    Tmp.x = (int)(fix2float<Precission>(PX)) - (PSurface->w/2);
    Tmp.y = (int)(fix2float<Precission>(PY)) - (PSurface->h/2);
    Tmp.w = PSurface->w;
    Tmp.h = PSurface->h;
    return Tmp;
}

void CCar::DeAccelerate()
{
    if(PCanMove)
    {
        if(PSpeed > 0)
            PSpeed -= 5*PAccelStep;
        else
        {
            if(PSpeed > -(5*PAccelStep))
            {
                //PBounce = false;
                PSpeed = 0;
            }
            else
                PSpeed += 5*PAccelStep;
        }

        //PAcceleration = 0;
        PVelY = fixmul<Precission>(PSpeed,SinCosTable.GetSin(PAngle));
        PVelX = fixmul<Precission>(PSpeed,SinCosTable.GetCos(PAngle));
    }


}

void CCar::Accelerate()
{
    if(PCanMove)
    {
        if(!PJumping && !PBounce && !PResetting)
        {
            if(!PReplayRecording)
                PReplayRecording = true;

            if(PAcceleration + PAccelStep > PMaxAcceleration)
            {
                if(PAcceleration - PAccelStep > PMaxAcceleration)
                    PAcceleration -= PAccelStep;
                else
                    PAcceleration = PMaxAcceleration;
            }
            else
                PAcceleration += PAccelStep;

          //  if (Reverse)
             //   PSpeed -= PAcceleration;
           // else


            if(PSpeed +PAcceleration > PMaxSpeed)
            {
                if(PSpeed - PAcceleration > PMaxSpeed)
                    PSpeed -= 5*PAccelStep;
                else
                    PSpeed =  PMaxSpeed;
            }
            else
            {

                PSpeed +=PAcceleration;
            }



            PVelY = fixmul<Precission>(PSpeed,SinCosTable.GetSin(PAngle));
            PVelX = fixmul<Precission>(PSpeed,SinCosTable.GetCos(PAngle));

        }
    }
}


void CCar::AccelerateNitro()
{
    if(!PJumping && !PBounce && !PResetting)
    {


        if(PAcceleration + 10*PAccelStep > PMaxAccelerationNitro)
            PAcceleration = PMaxAccelerationNitro;
        else
            PAcceleration += 10*PAccelStep;


      //  if (Reverse)
         //   PSpeed -= PAcceleration;
       // else



        if(PSpeed +PAcceleration < PMaxSpeedNitro)
        {
            PSpeed +=  PAcceleration;
        }
        else
        {

            PSpeed += (PMaxSpeedNitro - PSpeed);
            if (PSpeed < -PMaxSpeedNitro)
                PSpeed = -PMaxSpeedNitro;
        }


        PVelY = fixmul<Precission>(PSpeed,SinCosTable.GetSin(PAngle));
        PVelX = fixmul<Precission>(PSpeed,SinCosTable.GetCos(PAngle));

    }
}

void CCar::Draw(SDL_Surface *Surface, CCamera *Camera ) {
    if(PVisible)
    {
        SDL_Rect Dst;
        Dst.x = Camera->GetCenterPosX((int)(fix2float<Precission>(PX))) - (PShadow->w/2);
        Dst.y = Camera->GetCenterPosY((int)(fix2float<Precission>(PY))) - (PShadow->h/2);
        Dst.w = PShadow->w;
        Dst.h = PShadow->h;
        SDL_BlitSurface(PShadow,NULL,Surface,&Dst);

        Dst.x = Camera->GetCenterPosX((int)(fix2float<Precission>(PX))) - (PSurface->w/2);
        Dst.y = Camera->GetCenterPosY((int)(fix2float<Precission>(PY))) - (PSurface->h/2);
        Dst.w = PSurface->w;
        Dst.h = PSurface->h;
        SDL_BlitSurface(PSurface,NULL,Surface,&Dst);

        //rectangleRGBA(Surface,Dst.x,Dst.y,Dst.x+Dst.w,Dst.y+Dst.h,255,0,0,255);
//        if(SDL_MUSTLOCK(Surface))
//            SDL_LockSurface(Surface);
//        PutPixel(Surface,((int)(fix2float<Precission>(PX))  ) ,(int)(fix2float<Precission>(PY))NDOW_HEIGHT,SDL_MapRGB(Surface->format,0,0,255));
//        if(SDL_MUSTLOCK(Surface))
//            SDL_UnlockSurface(Surface);

    }
}


bool CCar::CheckMaskCollision(SDL_Rect Position)
{

    bool Tmp=false;
    if(CollideRect(Position))
    {
        int Y;
        int X;
        SDL_Rect Rect;
        Rect.x = max(GetRect().x,Position.x)-GetRect().x;
        Rect.y = max(GetRect().y,Position.y)-GetRect().y;
        Rect.w = min(GetRect().x + GetRect().w-1,Position.x + Position.w -1)- GetRect().x;
        Rect.h = min(GetRect().y + GetRect().h-1,Position.y + Position.h - 1)- GetRect().y;
        if(SDL_MUSTLOCK(PMaskSurface))
            SDL_LockSurface(PMaskSurface);
        for(X= Rect.x;X <= Rect.w;X++)
            for ( Y= Rect.y;Y <= Rect.h;Y++)
            {
               // printf("%d %d\n",X,Y);
                if(GetPixel(PMaskSurface,X,Y) == SDL_MapRGB(PMaskSurface->format,0,0,0))
                {
                    Tmp = true;
                    break;
                }
            }

      //  printf("%d %d %d %d\n",Rect.x,Rect.y,Rect.w,Rect.h);
        //SDL_FillRect(Dst,&Rect,SDL_MapRGB(Dst->format,0,0,0));
        if(SDL_MUSTLOCK(PMaskSurface))
            SDL_UnlockSurface(PMaskSurface);

	}
	return Tmp;

}
// wrong ?
bool CCar::CollideRect(SDL_Rect Rect)
{
     bool Tmp = false;

    if (!(GetRect().x >= Rect.x+Rect.w-1 || GetRect().x + GetRect().w-1 <= Rect.x ||
          GetRect().y >= Rect.y+Rect.h-1 || GetRect().y + GetRect().h-1 <= Rect.y))
        {
                //printf("Correct\n");
                Tmp = true;
        }
           // printf("\n");
	return Tmp;
}


bool CCar::CheckPixelCollision(SDL_Rect Rect)
{
    int X,Y;
    if (SDL_MUSTLOCK(PSurface))
        SDL_LockSurface(PSurface);


    for(X=0;X<PSurface->w;X++)
        for(Y=0;Y<PSurface->h;Y++)
        {
            if(GetPixel(PSurface,X,Y) != SDL_MapRGB(PSurface->format,255,0,255))
            {
                //printf("comparing %d %d -> (%d,%d,%d,%d)",(int)(fix2float<Precission>(PX)) + X, (int)(fix2float<Precission>(PY))  +Y,Rect.x,Rect.y,Rect.x + Rect.w,Rect.y + Rect.h);
                if(((int)(fix2float<Precission>(PX))- (PSurface->w/2) + X >= Rect.x) && ((int)(fix2float<Precission>(PX))+X - (PSurface->w/2)< Rect.x + Rect.w) && ((int)(fix2float<Precission>(PY))+Y - (PSurface->h/2)>=Rect.y)  && ((int)(fix2float<Precission>(PY))+ Y - (PSurface->h/2)< Rect.y + Rect.h))
                {

                   // printf(" true \n");
                    if (SDL_MUSTLOCK(PSurface))
                        SDL_UnlockSurface(PSurface);
                    return true;
                }
               //else
                   // printf(" false \n");
            }
        }
    if (SDL_MUSTLOCK(PSurface))
        SDL_UnlockSurface(PSurface);
    return false;
}

bool CCar::CheckPixelCollisionPoint(int X, int Y)
{
    bool Tmp = false;
    if((X >= GetRect().x) && (X < GetRect().x + GetRect().w) &&
       (Y >= GetRect().y) && (Y < GetRect().y + GetRect().h))
       {
           //printf("Yup %d %d\n",X%PSurface->w,Y%PSurface->h);
            if (SDL_MUSTLOCK(PSurface))
                SDL_LockSurface(PSurface);
            if(GetPixel(PSurface,X%PSurface->w,Y%PSurface->h) != SDL_MapRGB(PSurface->format,255,0,255))
                Tmp = true;
            if (SDL_MUSTLOCK(PSurface))
                        SDL_UnlockSurface(PSurface);
       }
    return Tmp;
}

bool CCar::CheckPositionCollision(SDL_Rect Rect)
{
   // printf("comparing %d %d -> (%d,%d,%d,%d)",(int)(fix2float<Precission>(PX)), (int)(fix2float<Precission>(PY)),Rect.x,Rect.y,Rect.x + Rect.w,Rect.y + Rect.h);
    if(((int)(fix2float<Precission>(PX))>= Rect.x) && ((int)(fix2float<Precission>(PX))< Rect.x + Rect.w) && ((int)(fix2float<Precission>(PY) >= Rect.y) && ((int)(fix2float<Precission>(PY))< Rect.y + Rect.h)))
    {
     //    printf(" true \n");
        return true;
    }
    else
    {
       // printf(" false \n");
        return false;
    }
}

void CCar::SetReplayData(vector<SPoint> ReplayData)
{
    SPoint Point;
    if(!Points.empty())
        Points.erase(Points.begin(),Points.end());
    vector<SPoint>::iterator Iter = ReplayData.end();
    while (Iter != ReplayData.begin())
    {
        Point.X = Iter->X;
        Point.Y = Iter->Y;
        Point.VelY = Iter->VelY;
        Point.VelX = Iter->VelX;
        Point.Angle = Iter->Angle;
        Point.JumpHeight = Iter->JumpHeight;
        Point.Bouncing = Iter->Bouncing;
        Points.push_back(Point);
        Iter--;
    }
}

void CCar::EraseReplayData()
{
    if(!Points.empty())
        Points.erase(Points.begin(),Points.end());
}
