#ifndef CPART_H
#define CPART_H

#include <SDL/SDL.h>
#include "fixed_class.h"
#include "Race.h"
#include <SDL/SDL_gfxPrimitives.h>
#include "CPartsManager.h"

using namespace fixedpoint;

extern const int WINDOW_HEIGHT;
extern const int WINDOW_WIDTH;

class CPartsManager;
class CPart
{
    protected:

        int PGroup; //group to wich it belongs
        int PId ; // unique id indentiefing the part
        int PZ; // Layer for sorting
        SDL_Surface *PSurface;
        SDL_Rect PLocation;
    public:
        CPartsManager *ParentList;
        CPart(int X,int Y,int W,int H,SDL_Surface *Surface);
        virtual ~CPart();
        virtual void Draw(SDL_Surface *Dst);
        virtual void Move();
        virtual inline SDL_Rect GetLocation() {return PLocation;}
        virtual inline SDL_Rect GetRealLocation() {return PLocation;}
        inline int GetId() {return PId;}
        inline int GetZ() {return PZ;}
        inline int GetGroup() {return PGroup;}
};

#endif
