#ifndef CREPLAYCAR_H
#define CREPLAYCAR_H

#include "CCar.h"

class CReplayCar : public CCar
{
    private:
        long PTicks;
    public:
        CReplayCar(char* filename,char* filenamemask,char* filenameshadow,int Xin,int Yin,int Angle) : CCar(filename,filenamemask,filenameshadow,Xin,Yin,Angle) {PTicks=1;PVisible=false;PId = DREPLAYCARID;}

        void Move()
        {

            if(!Points.empty())
            {
                vector<SPoint>::iterator Iter = Points.end()-PTicks;
                if(Iter > Points.begin())
                {
                    PTicks++;
                    PX = Iter->X;
                    PY = Iter->Y;
                    PAngle = Iter->Angle;
                    PJumpHeight=Iter->JumpHeight;
                    if (Iter->Bouncing)
                        SetAngleNoUpdate(PAngle);
                    else
                    {
                        UpdateAngle();
                    }


                }
                //Points.pop_back();

            }
        }

        void Step(int Ticks)
        {
            if(!Points.empty())
            {
                PTicks+=Ticks;
                vector<SPoint>::iterator Iter = Points.end()-PTicks;
                if(Iter > Points.begin())
                {
                    PX = Iter->X;
                    PY = Iter->Y;
                    PAngle = Iter->Angle;
                    UpdateAngle();
                }
                //Points.pop_back();

            }
        }
        void ResetReplay() {PTicks=1;}


        void Draw(SDL_Surface *Surface, CCamera *Camera, CCar *PlayerCar)
        {
            int XDiff = 0;
            int YDiff = 0;
            if(PVisible)
            {
                if((this->GetIntX() >= Camera->CameraRect.x) && (this->GetIntX() <= Camera->CameraRect.x + Camera->CameraRect.w) &&
                   (this->GetIntY() >= Camera->CameraRect.y) && (this->GetIntY() <= Camera->CameraRect.y + Camera->CameraRect.h))
                {
                    XDiff = (int) (this->GetIntX() - PlayerCar->GetIntX());
                    YDiff = (int) (this->GetIntY() - PlayerCar->GetIntY());
                    SDL_Rect Dst;
                    Dst.x = Camera->GetCenterPosX(PlayerCar->GetIntX()) + XDiff - (PShadow->w/2);
                    Dst.y = Camera->GetCenterPosY(PlayerCar->GetIntY()) + YDiff - (PShadow->h/2);
                    Dst.w = PShadow->w;
                    Dst.h = PShadow->h;
                    SDL_BlitSurface(PShadow,NULL,Surface,&Dst);

                    Dst.x = Camera->GetCenterPosX(PlayerCar->GetIntX()) + XDiff - (PSurface->w/2);
                    Dst.y = Camera->GetCenterPosY(PlayerCar->GetIntY()) + YDiff - (PSurface->h/2);
                    Dst.w = PSurface->w;
                    Dst.h = PSurface->h;
                    SDL_BlitSurface(PSurface,NULL,Surface,&Dst);
                }

                //rectangleRGBA(Surface,Dst.x,Dst.y,Dst.x+Dst.w,Dst.y+Dst.h,255,0,0,255);
//                if(SDL_MUSTLOCK(Surface))
//                    SDL_LockSurface(Surface);
//                PutPixel(Surface,(int)(fix2float<Precission>(PX))% WINDOW_WIDTH,(int)(fix2float<Precission>(PY))% WINDOW_HEIGHT,SDL_MapRGB(Surface->format,0,0,255));
//                if(SDL_MUSTLOCK(Surface))
//                    SDL_UnlockSurface(Surface);

            }
        }

        ~CReplayCar()
        {
            printf("bleh\n");
            if(POriginalSurface)
            {
                SDL_FreeSurface(POriginalSurface);
                POriginalSurface = NULL;
            }
            if(PSurface)
            {
                SDL_FreeSurface(PSurface);
                PSurface = NULL;
            }
        }


};
#endif
