#ifndef CWAYPOINT_H
#define CWAYPOINT_H

#include "CPart.h"

class CWayPoint : public CPart
{
    protected:
        bool PScanned;
        bool PVisible;
    public:
        CWayPoint (int X,int Y,int W,int H,SDL_Surface *Surface) : CPart (X,Y,W,H,Surface)
        {
            PId = DWAYPOINTID;
            PGroup = DGROUPWAYPOINT;
            PScanned = false;
            PVisible = true;
        }
        void SetScanned (bool Scanned) {PScanned = Scanned;}
        bool GetScanned () {return PScanned;}
        void Hide() {PVisible = false;}
        void UnHide() {PVisible = true;}
        bool IsVisible() {return PVisible;}
        virtual void Draw(SDL_Surface*Dst)
        {
            if(PVisible)
            {
                if(!PScanned)
                    rectangleRGBA(Dst,PLocation.x,PLocation.y,PLocation.x + PLocation.w-1,PLocation.y+PLocation.h-1,255,0,0,255);
                else
                    rectangleRGBA(Dst,PLocation.x,PLocation.y,PLocation.x + PLocation.w-1,PLocation.y+PLocation.h-1,255,255,255,255);
            }
        }
        virtual ~CWayPoint(){}

};
#endif
